package wipi_book_io;

import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;
import org.kwis.msp.db.*;
import org.kwis.msp.io.*;
import java.io.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class AddressBook extends Jlet implements ActionListener {

    //ڵ ߰
    public int MODE_ADD = 0;
    // 
    public int MODE_LIST =1 ;
    //ڵ ȸ
    public int MODE_VIEW =2;

    // ȭ 
    int m_mode = MODE_ADD ;

    //̸
    TextFieldComponent m_textfield1 = null ;
    //ȭȣ
    TextFieldComponent m_textfield2 = null ;
    //ּ
    TextFieldComponent m_textfield3 = null ;
    //̸
    TextFieldComponent m_textfield4 = null ;

    //߰ ư
    ButtonComponent btn_ok = null ;
    //Ʈ ̵ư
    ButtonComponent btn_list = null ;

    ShellComponent sh = null ;

    MyCard    card = null ;

    public AddressBookData address = null ;

    public AddressBook() {
    }
    protected void destroyApp(boolean parm1) {
        /**@todo: implement this org.kwis.msp.lcdui.Jlet abstract method*/
    }
    protected void startApp(String[] parm1) {
        /**@todo: implement this org.kwis.msp.lcdui.Jlet abstract method*/
        AnnunciatorComponent m_anc = new AnnunciatorComponent(false) ;
        m_anc.show();
        load();
    }

    /**
     * Ʈ о δ.
     */
    private void load(){
        sh = new ShellComponent();
        sh.setTitle("Multi-Column");

        if(m_mode == MODE_LIST){
            sh.show();
            return ;
        }

        FormComponent frm = new FormComponent();
        frm.setPacked(true);
        // ̸
        frm.addComponent(new LabelComponent("̸"));
        if( m_mode == MODE_ADD )
            m_textfield1 =   new TextFieldComponent("",TextComponent.CONSTRAINT_ANY);
        else if( m_mode == MODE_VIEW)
            m_textfield1 =   new TextFieldComponent(address.name,TextComponent.CONSTRAINT_ANY);
        frm.addComponent(m_textfield1);
        //ȭ ȣ
        frm.addComponent(new LabelComponent("ȭȣ"));
        if( m_mode == MODE_ADD )
            m_textfield2 =   new TextFieldComponent("",TextComponent.CONSTRAINT_ANY);
        else if( m_mode == MODE_VIEW)
            m_textfield2 =   new TextFieldComponent(address.phone,TextComponent.CONSTRAINT_ANY);
        frm.addComponent(m_textfield2);
        //ּ
        frm.addComponent(new LabelComponent("ּ"));
        if( m_mode == MODE_ADD )
            m_textfield3 =   new TextFieldComponent("",TextComponent.CONSTRAINT_ANY);
        else if( m_mode == MODE_VIEW)
            m_textfield3 =   new TextFieldComponent(address.addr,TextComponent.CONSTRAINT_ANY);
        frm.addComponent(m_textfield3);
        //̸
        frm.addComponent(new LabelComponent("̸"));
        if( m_mode == MODE_ADD )
            m_textfield4 =   new TextFieldComponent("",TextComponent.CONSTRAINT_ANY);
        else if( m_mode == MODE_VIEW)
            m_textfield4 =   new TextFieldComponent(address.email,TextComponent.CONSTRAINT_ANY);
        frm.addComponent(m_textfield4);

        btn_list = new ButtonComponent("Ʈ̵",null);
        btn_list.setActionListener(this,null);

        if( m_mode == MODE_ADD ){
            frm.addComponent(btn_list);
            sh.addComponent(frm);
            btn_ok = new ButtonComponent("DB ߰",null);
            btn_ok.setActionListener(this,null);
            sh.setCommand(btn_ok,false);
        }else if(m_mode == MODE_VIEW ){
            sh.addComponent(frm);
            sh.setCommand(btn_list,false);
        }
        sh.show();
    }

    /**
     * Card  stack ִ´.
     */
    private void draw(){
        Display dis = Display.getDefaultDisplay();
        card = new MyCard();
        dis.pushCard(card);
    }


    /**
     * ư   .
     * @param p0
     * @param p1
     */
    public  void action(Component p0, Object p1){
        // Ʈ ̵ϴ ư
        if(p0.equals(btn_list)){
            m_mode = MODE_LIST;
            load();
            draw();
        }
        //ڵ ߰ ư
        if(p0.equals(btn_ok)){
            addColumns(m_textfield1.getString(), m_textfield2.getString(), m_textfield3.getString() , m_textfield4.getString());
            m_mode = MODE_LIST;
            load();
            draw();
        }
    }

    /**
     * ڵ带 ͺ̽ ִ´.
     * @param id
     * @param phone
     * @param addr
     * @param email
     */
    private void  addColumns(String name , String phone, String addr , String email){
        AddressBookData data = new AddressBookData(name, phone,addr,email);
        try{
            DataBase db = DataBase.openDataBase("addrbook",100,true, FileSystem.PRIVATE_ACCESS);
            db.insertRecord(data.toByte());

        }catch(Exception e){
        }
    }

    /**
     * Ʈ ִ CARD
     */
    class MyCard extends Card implements  ScrollListAdaptor {

        ScrollList scroll = null ;
        ListItem[] m_listsItem = null ;

        public MyCard(){
            super(true);
            m_listsItem = getListItems() ;
            scroll = new ScrollList(this,0,33,getWidth(),getHeight()-53 , m_listsItem);
            scroll.setSelectionMode(true);
            scroll.setMarqueActive(false);
        }

        /**
         * 庰  Ʈ  ´.
         * @param mode
         * @return
         */
        public  ListItem[] getListItems(){
            ListItem[]   listsItem = null;
            AddressBookData data = null;
            try{
                DataBase db = DataBase.openDataBase("addrbook",100,true, FileSystem.PRIVATE_ACCESS);
                int[] records  = db.sortRecord(new MyFilter(null),new DataComparatorReverseString() );
                listsItem = new ListItem[records.length];
                for(int i = 0 ; i < records.length ; i++ ) {
                    data = new AddressBookData(db.selectRecord(records[i]));
                    listsItem[i] = new ListItem(null,null,data.name,""+records[i],false);
                }
            }catch(Exception e){
            }
            return listsItem;
        }

        /**
         * ScrollList  ׸.
         * @param g
         */
        public void paint(Graphics g){
            // ʱ⿡ ع ׸ϴ.
            if(m_mode == MODE_LIST){
                g.setColor(0xFFFFFF);
                g.fillRect(0, 17, getWidth(), getHeight()-37 );
                g.setColor(0);
                g.drawString("ȭȣ",10,20,g.LEFT);
                scroll.drawList(g);
                g.setColor(0x991299);
                g.fillRect(0,getHeight()-15 , getWidth() , getHeight());
                g.setColor(0xFFFFFF);
                g.drawString(" " , 0 , getHeight() - 12 ,g.LEFT);
                g.drawString("ڵ߰" , getWidth() ,getHeight() -12 ,g.RIGHT);
            }
        }

        /**
         * ڷκ ŰԷ ް ó
         * @param type
         * @param key
         * @return
         */
        public boolean  keyNotify(int type, int key){
            if(m_mode == MODE_LIST){
                if(type == EventQueue.POINT_RELEASED){
                    switch(Display.getGameAction(key)){
                        case EventQueue.UP :
                            scroll.moveUp();
                                break;
                        case EventQueue.DOWN :
                            scroll.moveDown();
                                break;
                        case EventQueue.RIGHT :
                            scroll.moveRight();
                                break;
                        case EventQueue.LEFT :
                            scroll.moveLeft();
                                break;
                        case EventQueue.FIRE :
                        case EventQueue.SOFT1 :
                            m_mode=MODE_VIEW;
                            int recordid = Integer.parseInt(scroll.SelectPressed().command);
                            System.out.println("recordid ="+recordid);
                            try{
                                DataBase db = DataBase.openDataBase("addrbook",100,true, FileSystem.PRIVATE_ACCESS);
                                address =  new AddressBookData(db.selectRecord(recordid));
                            }catch(Exception e){
                            }
                            load();
                            break;
                        case EventQueue.CLEAR :
                                break;
                        case EventQueue.SOFT2 :
                        case EventQueue.SOFT3 :
                            m_mode = MODE_ADD;
                            load();
                            draw();
                            break;
                    }
                    repaint();
                }
                // Ű ̺Ʈ shellComponent ޵ ʰ Ѵ.
                return true;
            }
            return false ;
        }

        /**
         * ScrollListAdaptor 
         */
        public void drawScrollList(){
            repaint();
        }
    }
}