package wipi_book_network;

import org.kwis.msp.lwc.*;
import org.kwis.msp.lcdui.*;
import org.kwis.msf.io.*;
import java.io.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class DatagramClient extends Jlet  implements ActionListener{

    Socket m_udpsocket = null ;
    Message m_udpdatagram = null ;

    MyCard card = null ;
    ShellComponent sh = null ;
    TextFieldComponent m_textfield = null ;
    TextBoxComponent   m_textbox   = null ;
    ButtonComponent    btn          = null ;

    public DatagramClient() {
    }

    protected void destroyApp(boolean parm1) {
        /**@todo: implement this org.kwis.msp.lcdui.Jlet abstract method*/
    }

    protected void startApp(String[] parm1) {
        /**@todo: implement this org.kwis.msp.lcdui.Jlet abstract method*/
        AnnunciatorComponent m_anc = new AnnunciatorComponent(false) ;
        m_anc.show();
        initSocket();
        load();
        draw();
    }

    /**
     * Card ׸.
     */
    private void draw(){
        Display dis = Display.getDefaultDisplay() ;
        card = new MyCard();
        dis.pushCard(card);
    }

    /**
     *  Ʈ ߰Ѵ.
     */
    private void load(){
        sh  = new ShellComponent();
        sh.setTitle("UDP CLIENT");
        FormComponent frm = new FormComponent();
        frm.addComponent(new LabelComponent(" ޼",(Image) null ));
        m_textfield = new TextFieldComponent("",TextComponent.CONSTRAINT_ANY);
        frm.addComponent(m_textfield);
        sh.addComponent(frm);
        ButtonComponent btn = new ButtonComponent("", null);
        btn.setActionListener(this,null);
        sh.setCommand(btn,false);
        sh.show();
    }


    /**
     *  UDP  Ѵ.
     */
    private void initSocket(){
        try
        {
          int ret = Network.connect();
          if (ret != -1)
          {
            try{
                m_udpsocket = URL.find("datagram://:5000");
            }catch(Exception e){
                System.out.println("   ϴ. ");
            }
          }else
          {
                System.out.println("ͳ    ϴ.");
          }
        }catch(Exception e){
            System.out.println("ͳ ʱȭ   ϴ. ");
        }
    }


    /**
     *  ڷκ Է¹   Ѵ.
     */

    private void send(){
        try{
            byte[]  rcvbuf = null ;
            rcvbuf = m_textfield.getString().getBytes();
            m_udpdatagram = new Message("127.0.0.1:5001",rcvbuf);
            m_udpsocket.send(m_udpdatagram);
        }catch(Exception e){
            System.out.println("Datagram   ϴ. ");
        }
    }

    /**
     * ""ư  ó ƾ
     * @param p0
     * @param p1
     */
    public void action(Component p0, Object p1){
        try{
            send();
            new ListenThread().start();
        }catch(Exception e){}
    }


    /**
     *   Ÿ д  ϴ 
     */
    class ListenThread extends Thread  {

        byte[]  rcvbuf = null ;
        public ListenThread(){
            rcvbuf = new byte[200];
            m_udpdatagram = new Message("127.0.0.1",rcvbuf);
        }


        /**
         *  
         */
        public void run(){
            try{
                System.out.println("waiting...");
                m_udpsocket.recv(m_udpdatagram);
                byte[] rcvdata = m_udpdatagram.getData();
                System.out.println("rcvbyte.length="+rcvdata.length);
                card.MODE_VIEW = true;
                card.rcvmsg = new String(rcvdata);
                card.repaint();

            }catch(Exception e){
                System.out.println("Exception "+e.getMessage());
            }
        }
    }

    class MyCard extends  Card{

        public String rcvmsg = "" ;

        boolean MODE_VIEW=false ;

        public MyCard(){
            super(true);
        }

        public void paint(Graphics g){
            if(MODE_VIEW){
                // ʱ⿡ ع ׸ϴ.
                g.setColor(0xFFFFFF);
                g.fillRect(0, 0, getWidth(), getHeight());
                // ڿ ϴ.
                g.setColor(0);
                Image image = null;
                g.drawString(rcvmsg,10,40,Graphics.LEFT);
            }
        }

        public boolean  keyNotify(int type, int key){
            if(type == EventQueue.POINT_RELEASED){
                if(MODE_VIEW ){
                    MODE_VIEW  = false ;
                    load();
                    draw();
                    repaint();
                    return true;
                }
            }
            return false ;
        }
    }


}