package server;

import java.util.ArrayList;
import network.UserInterface;
import network.UserContainer;

/**
 * <p>Title: ϳ äùμ äûڵ ۿ ϴ ü</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class ChatRoom
{
  private String m_title = null; //äù 
  private byte m_no = (byte)-1; //äù ȣ
  private UserInterface m_users = null; //Ŭ̾Ʈ  ̽
  private int m_maxClient = -1; //ۿ  ִ Ŭ̾Ʈ 
  private String m_passwd = ""; //äù ȣ

  //not use
  private ChatRoom() {}

  /**
   * ʱȭ
   *
   * @param title äù 
   * @param roomNo äù ȣ
   * @param maxUser ִ äüο
   * @param passwd äùȣ
   * */
  public ChatRoom(String title, byte roomNo, int maxUser, String passwd)
  {
    m_title = title;
    m_no = roomNo;
    this.m_passwd = passwd;

    m_maxClient = maxUser+1; //9 忡 Ͽ

    //Ŭ̾Ʈ   
    m_users = new UserContainer(m_maxClient);
  }

  /**
   * äû ߰
   *
   * @param id äû ̵
   * @return int  ο äû ø
   *    if (-1)
   *    then (ִڼ ʰ)
   * */
  public final int addClient(String id, Unit unit)
  {
    //Ŭ̾Ʈ ̵ 
    int serial = m_users.getUniqueId(); // ϴ Ŭ̾Ʈ ̵

    //äû 
    ChatUser usrInfo = new ChatUser(id);
    usrInfo.setSerial(serial);
    usrInfo.setUnit(unit);

    //Ŭ̾Ʈ ۿ ߰
    boolean ret = m_users.addClient(new Integer(serial), usrInfo);
    if (ret) return serial;
    else return -1;
  }

  /**
   * äû 
   *
   * @param serial äû ø
   * @return boolean Ű
   * */
  public final boolean removeClient(int serial)
  {
    boolean ret = m_users.removeClient(new Integer(serial));
    m_users.freeUniqueId(serial);
    return ret;
  }

  /**
   * äû 
   * @return ChatUser
   *    if (ChatUser == null)
   *    then (߸ ø)
   * */
  public final ChatUser getUser(int serial)
  {
    if (serial <= -1) return null;

    Object obj = m_users.getClient(new Integer(serial));
    if (obj != null) return (ChatUser)obj;
    else return null;
  }

  /**
   * äù  
   *
   * @return String 
   * */
  public final String getTitle()
  {
    return m_title;
  }

  /**
   * 泻 ϴ Ʈ 
   *
   * @return Object[] Ʈ
   * */
  public final Object[] getUsrList()
  {
    return m_users.getClientList();
  }

  /**
   * äù ȣ 
   *
   * @return byte ȣ
   * (!) 忡 ǰ, ȣ  1~99̸  100 ´
   * */
  public final byte getNo()
  {
    return m_no;
  }

  /**
   * äù ȣ  (ϰ ĭ ϵ)
   * @return String ȣ
   * */
  public final String getPasswd()
  {
    return this.m_passwd;
  }

  /**
   * äù 밡 ִο 
   * @return byte ִο (׻ < 9)
   * */
  public final byte getMaxUser()
  {
    return (byte)(m_maxClient - 1);
  }

  /**
   * ChatRoom 
   * */
  public static void main(String[] args)
  {
    ChatRoom chatRoom1 = new ChatRoom(
                                     ProtocolInterface.STANDBY_ROOM_TITLE,
                                     ProtocolInterface.STANDBY_ROOM,
                                     ProtocolInterface.MAX_STANDBY_ROOM_USER,
                                     "123"
                                      );
    int ret = chatRoom1.addClient("chulsu@orio.net", null);

    //ret  -1̸, ִ ڼ ʰ ǹѴ
    //忡ϸ ִڼ äù渶 9 ѵǾ ִ
    System.out.println("After Add : Result = "+ret+", "+chatRoom1.getTitle()+", "+chatRoom1.getNo());

    ChatUser usrInfo = chatRoom1.getUser(1);
    if (usrInfo != null)
      System.out.println("Usr Info : "+usrInfo.getId()+", "+usrInfo.getSerial());
    else
      System.out.println("Input Parameter Wrong ! So cannot found chat user !");
  }

}