/**
 * äù 
 * */

import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;
//import java.awt.event.ActionEvent;
import org.kwis.msf.io.*;
import java.io.*;
import java.io.IOException;


public class NewRoom implements Runnable,  ActionListener
{
//    private int йȣִ=5, οԷִ=1, äùִ=20, ִο=9;
    private int password_max_length=5, person_input_max_length=1, chatting_room_name_max_length=20, room_person_max=9;
    private ShellComponent sh = null;
    private FormComponent center = null;
    private FormComponent south = null;

//    private Image imgäù游=null, img=null, img=null, imgѱ=null;
    private Image img_make_chatting_room=null, img_cancel=null, img_make=null, img_hangul=null;
//   private CyementTextField tfäù=null, tfο=null, tfйȣ=null;
    private CyementTextField tf_chatting_room_name=null, tf_person=null, tf_password=null;

//    private ButtonComponent btn = null;
    private ButtonComponent btn_cancel = null;
//    private ButtonComponent btn = null;
    private ButtonComponent btn_make = null;
//    private ButtonComponent btnѱ = null;
    private ButtonComponent btn_hangul = null;
//    private String strBtn="", strBtn="", strBtnѱ="ѱ";
    private String strBtn_cancel="", strBtn_make="", strBtn_hangul="ѱ";

    private ClientUnit m_network = null; //Ŭ̾Ʈ Ʈp 

    //̾α
    private DialogComponent m_errDlg = null;

    /**
     * 
     * */
    private NewRoom(){}

    /**
     * 
     *
     * @param sh 
     * @param unit Ʈp
     * */
    public NewRoom(ShellComponent sh, ClientUnit unit)
    {
      this.m_network = unit;
      this.sh = sh;
      center = new FormComponent(true);//Horizon Layout
      south = new FormComponent(false);//Vertical Layout

      //ҽ ʱȭ
      imageLoading();//̹ ε

      //Ŀǵ  Ҷ  Ʈ  
      sh.removeAllComponents();

      load();

      //Ʈp ɿ ˻ Ʈp   ˸â
      if (!m_network.isEnable()) m_network.showErrorDlg("Ʈũ !");

      //б  
      if (m_network.isEnable()) m_network.startChatReader(this, null, null, null);
    }

    /**
     *  Ŀǵ带 εѴ
     * */
	private final void load()
    {
      //̺ 
      LabelComponent lbTitle = new LabelComponent("äù ", img_make_chatting_room);
      lbTitle.setBackground(0x000066);
      lbTitle.setForeground(0xFFFFFF);
      sh.setTitle(lbTitle);

      //äù
          //̺
      LabelComponent lb_chatting_room_title = new LabelComponent();
      lb_chatting_room_title.setLabel("äù ");
      lb_chatting_room_title.setBackground(0x99CCFF);
      lb_chatting_room_title.setForeground(0x0000FF);
      center.addComponent(lb_chatting_room_title);
          //ȭ Էâ
      tf_chatting_room_name = new CyementTextField("",  TextComponent.CONSTRAINT_ANY);
      tf_chatting_room_name.setMaxLength(chatting_room_name_max_length);
      center.addComponent(tf_chatting_room_name);

      //ο
          //̺
      LabelComponent lb_person = new LabelComponent();
      lb_person.setLabel("ο (ִ : "+room_person_max+" )");
      lb_person.setBackground(0x99CCFF);
      lb_person.setForeground(0x0000FF);
      center.addComponent(lb_person);
          //ο Էâ
      tf_person = new CyementTextField("",  TextComponent.CONSTRAINT_NUMBER);
      tf_person.setMaxLength(person_input_max_length);
      center.addComponent(tf_person);

      //йȣ
          //̺
      LabelComponent lb_password = new LabelComponent();
      lb_password.setLabel("йȣ()");
      lb_password.setBackground(0x99CCFF);
      lb_password.setForeground(0x0000FF);
      center.addComponent(lb_password);
          //ȭ Էâ
      tf_password = new CyementTextField("",  TextComponent.CONSTRAINT_PASSWORD);
      tf_password.setMaxLength(password_max_length);
      center.addComponent(tf_password);
          //ĭ ̺
      LabelComponent lb_blank = new LabelComponent();
      lb_blank.setLabel("");
      lb_blank.setBackground(0x99CCFF);
      lb_blank.setForeground(0x0000FF);
      center.addComponent(lb_blank);

      //command bar
      btn_cancel = new ButtonComponent("", img_cancel);
      btn_make = new ButtonComponent("", img_make);
      btn_hangul = new ButtonComponent("", img_hangul);
      btn_cancel.setActionListener(this, strBtn_cancel);
      btn_make.setActionListener(this, strBtn_make);
      btn_hangul.setActionListener(this, strBtn_hangul);

      south.addComponent(btn_cancel);
      south.addComponent(btn_make);
      south.addComponent(btn_hangul);

      // ̱
      sh.addComponent(center);
      sh.setCommand(south, false);
      sh.show();
	}

    /**
     * png غ
     * */
    private final boolean imageLoading()
    {
      try
      {
        img_make_chatting_room = Image.createImage("title_chat07.png");
        img_cancel = Image.createImage("bottom_01.png");
        img_make = Image.createImage("bottom_04.png");
        img_hangul = Image.createImage("bottom_03.png");
      }
      catch(Exception e){ return false; }

      return true;
    }

    /***
     * ư ׼ó
     */
    public void action(Component c, Object o)
    {
      if (m_network.isEnable())
      {
        String errMsg = null;
        String cmd = (String)o;

        if (tf_person.getString().equals("")) errMsg = "ο Էϼ!";
        if (tf_chatting_room_name.getString().equals("")) errMsg = "äù Էϼ!";

        if (errMsg != "" && errMsg != null)
        {
             DialogComponent caution = new DialogComponent(
                          new LabelComponent(errMsg),
                         "",
                         DialogComponent.TYPE_NONE);
             caution.setTimeout(1*1000);
             caution.show();
        }
        else
        {
          //ٽ Է  ֵ TextFieldʱȭ
          if (cmd.equalsIgnoreCase(strBtn_cancel))
          {
            tf_password.setString("");
            tf_person.setString("");
            tf_chatting_room_name.setString("");
            tf_chatting_room_name.setFocus();
          }
          //äôǷ ̵
          else if (cmd.equalsIgnoreCase(strBtn_make))
          {
            //Էµ  ִ ִο ˻
            if (!tf_person.getString().equals(""))
            {
              int userNum = Integer.parseInt(tf_person.getString());

              if (userNum > room_person_max || userNum < 0)
              {
                System.out.println("ο "+room_person_max+" մϴ!");
                tf_person.setFocus();
              }
              else
              {
                //äù 
                byte _person = Byte.parseByte(tf_person.getString().trim());
                String _room_title = tf_chatting_room_name.getString().trim();
                String _password = tf_password.getString().trim();
                this.m_network.make_chatroom(_person, _room_title, _password);
              }
            }
          }
          //ѱŰ 
          else if (cmd.equalsIgnoreCase(this.strBtn_hangul))
          {
            System.out.println("ѱ  غȵ..");
          }
        }
      }
    }

    /**
     *   ֱ
     *
     * @param result 
     * */
    /*
      Ʒθ   ׿ 
          Ʒθ :
          DialogComponent 
           ׿  Main Thread   ϰ ֽϴ.
      ̾α׸  ʽϴ
    */
    public final void showMakeChatRoomResult(byte result)
    {
      if (result == 0x00)//氹 ʰ  Ȥ 
      {
        m_errDlg = new DialogComponent(
                      new LabelComponent("äù  !"),
                     "",
                     DialogComponent.TYPE_NONE);
        m_errDlg.setTimeout(1*1000);

        //̾α ֱ
        Display.getDefaultDisplay().callSerially(this);
      }
      else if (result == 0x10) //äù  ߺ 
      {
        m_errDlg = new DialogComponent(
                      new LabelComponent("äù ߺ !"),
                     "",
                     DialogComponent.TYPE_NONE);
        m_errDlg.setTimeout(1*1000);

        //̾α ֱ
        Display.getDefaultDisplay().callSerially(this);
      }
      else //äù  
      {
        //äô  ä α׷ ᰡ ϹǷ    ֵ Ѵ
        StandbyRoom _chatting_waitting_room = new StandbyRoom(sh, this.m_network);
      }
    }

    //̾α ֱ
    public void run()
    {
      m_errDlg.show();
    }
}
